<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt'
import { ref, watch } from 'vue'

const receiptStore = useReceiptStore()
const cash = ref('')
const selectedPaymentType = ref('')

const updatePaymentType = () => {
  receiptStore.receipt.paymentType = selectedPaymentType.value
}

const updateCash = (value: string) => {
  if (value === '') {
    receiptStore.receipt.receivedAmount = 0
  } else {
    receiptStore.receipt.receivedAmount = parseFloat(value)
  }
}

watch(selectedPaymentType, (newValue) => {
  receiptStore.receipt.paymentType = newValue
})

const required = (v: string | boolean) => !!v || 'Field is required'
</script>

<template>
  <v-container class="font">
    <v-row no-gutters>
      <v-col cols="6" class="mb-5">Total :</v-col>
      <v-col cols="6" class="mb-5">{{ receiptStore.receipt?.total + ' ฿' }}</v-col>

      <v-col cols="6" class="mb-5">Member Discount :</v-col>
      <v-col cols="6" class="mb-5">{{ '- ' + receiptStore.receipt?.memberDiscount + ' ฿' }}</v-col>

      <v-col cols="6" class="mb-5">Total Net :</v-col>
      <v-col cols="6" class="mb-5">{{ receiptStore.receipt?.totalNet + ' ฿' }}</v-col>

      <v-col cols="5"
        ><v-combobox
          v-model="selectedPaymentType"
          :items="['Cash', 'Credit Card', 'Qr-Code']"
          label="Payment Type"
          dense
          clearable
          @input="updatePaymentType"
          variant="outlined"
        ></v-combobox> </v-col
      ><v-spacer></v-spacer>
      <v-col cols="6" class="flex-col"
        ><v-text-field
        v-model="cash"
        :rules="[required]"
        class="mb-3 input"
        clearable
        label="Cash"
        prepend-inner-icon="mdi-cash"
        variant="outlined"
        @input="updateCash(cash)"
        @keyup.enter="receiptStore.calReceipt()"
      ></v-text-field></v-col>

      <v-col cols="6" class="mb-2">Change :</v-col>
      <v-col cols="6" class="mb-2">{{ receiptStore.receipt?.change + ' ฿' }}</v-col>
    </v-row>
  </v-container>
</template>

<style scoped>
.font {
  font-family: 'Kanit';
}

.input-cash {
  width: 150px;
  height: 56px;
  background: transparent;
  border: none;
  outline: none;
  border: 2px solid rgba(8, 8, 8, 0.2);
  border-radius: 10px;
  padding: 20px 45px 20px 20px;
}

.flex-col {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  height: 100%;
}
</style>
